/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1991, Innovative Data Concepts, Inc.
 | All Rights Reserved.
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call  1-215-443-9705.
 *-V--------------------------------------------------------------------*
 | $Header:   tcxlatr.h     552.0   17 Mar 1991 18:27:16  $
 |
 | $Log:   tcxlatr.h    $
 *-D--------------------------------------------------------------------*
 | <TCXLatr.h>: Attribute code definitions for TCXL video functions.
 *-N-----------------------[ Notes and Caveats ]------------------------*
 | 1) Included by <TCXLvid.h>.
 | 2) Light background colors are not currently supported, they are
 |    always BLINKING attributes.
 *======================================================================*/
#ifndef  _TCXLatr_
#  define   _TCXLatr_ 1
#ifndef  BLACK                         /*- Foreground Color ------------*/
#  define   BLACK       0x00           /* Black                         */
#  define   BLUE        0x01           /* Blue                          */
#  define   GREEN       0x02           /* Green                         */
#  define   CYAN        0x03           /* Cyan                          */
#  define   RED         0x04           /* Red                           */
#  define   MAGENTA     0x05           /* Magenta                       */
#  define   BROWN       0x06           /* Brown                         */
#  define   LGREY       0x07           /* Light grey (white)            */
#  define   DGREY       0x08           /* Dark grey                     */
#  define   LBLUE       0x09           /* Light blue                    */
#  define   LGREEN      0x0A           /* Light green                   */
#  define   LCYAN       0x0B           /* Light cyan                    */
#  define   LRED        0x0C           /* Light red                     */
#  define   LMAGENTA    0x0D           /* Light magenta                 */
#  define   YELLOW      0x0E           /* Yellow                        */
#  define   WHITE       0x0F           /* Intense white                 */
#  define   INTENSE     0x08           /* Intensity bit                 */
                                       /*- Background color ------------*/
#  define   _BLACK      0x00           /* Black                         */
#  define   _BLUE       0x10           /* Blue                          */
#  define   _GREEN      0x20           /* Green                         */
#  define   _CYAN       0x30           /* Cyan                          */
#  define   _RED        0x40           /* Red                           */
#  define   _MAGENTA    0x50           /* Magenta                       */
#  define   _BROWN      0x60           /* Brown                         */
#  define   _LGREY      0x70           /* White                         */
#  define   _DGREY      0x80           /* Blink/dark grey               */
#  define   _LBLUE      0x90           /* Blink/light blue              */
#  define   _LGREEN     0xA0           /* Blink/light green             */
#  define   _LCYAN      0xB0           /* Blink/light cyan              */
#  define   _LRED       0xC0           /* Blink/light red               */
#  define   _LMAGENTA   0xD0           /* Blink/light magenta           */
#  define   _YELLOW     0xE0           /* Blink/light yellow            */
#  define   _WHITE      0xF0           /* Blink/light white             */
#  define   _BLINK      0x80           /* Blink/intensity bit           */
                                       /*- Monochrome ------------------*/
#  define   MONO_N      0x07           /* Normal                        */
#  define   MONO_I      0x0F           /* Intense                       */
#  define   MONO_U      0x01           /* Underline                     */
#  define   MONO_IU     0x09           /* Intense underline             */
#  define   MONO_R      0x70           /* Reverse                       */
#  define   MONO_NB     0x87           /* Blink normal                  */
#  define   MONO_IB     0x8F           /* Blink intense                 */
#  define   MONO_UB     0x81           /* Blink underline               */
#  define   MONO_IUB    0x89           /* Blink intense underline       */
#  define   MONO_RB     0xF0           /* Blink reverse                 */
#  define   MONO_INT    0x80           /* Blink bit                     */
#endif   /* BLACK */
#endif   /*- _TCXLatr_  : End of TCXLatr.h -----------------------------*/
