/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1991, Innovative Data Concepts, Inc.
 | All Rights Reserved.
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call  1-215-443-9705.
 *-V--------------------------------------------------------------------*
 | $Header:   tcxlbox.h     552.0   17 Mar 1991 18:27:12  $
 |
 | $Log:   tcxlbox.h    $
 *-D--------------------------------------------------------------------*
 | <TCXLbox.h> : Definitions and declarations for box-drawing.
 *-N-----------------------[ Notes and Caveats ]------------------------*
 | 1) The BoxXX(b) macros REQUIRE declaration and initialization of a
 |    pointer <b> to one of the box-type arrays as:
 |       BytP  <b> = BoxPtr(t);
 |    where <t> is one of:
 |       0 = all single lines             3 = vert single, horiz double
 |       1 = all double lines             4 = heavy lines
 |       2 = horiz single, vert double    5 = spaces
 *======================================================================*/
#ifndef  _TCXLbox_
#  define   _TCXLbox_   1              /* Only once!                    */
#  ifndef   _TCXLdef_
#     include  <TCXLdef.h>             /* System definitions            */
#  endif
GBL   BytP  CDC   _BoxTbl[];  /*- global box-drawing table -------------*/

#  define BoxPtr(t)  (_BoxTbl[t])      /* Point to box-type array       */
#  define BoxTL(b)   (b)[0]            /* Top Left corner               */
#  define BoxTH(b)   (b)[1]            /* Top Horizontal line           */
#  define BoxTR(b)   (b)[2]            /* Top Right corner              */
#  define BoxLV(b)   (b)[3]            /* Left Vertical line            */
#  define BoxRV(b)   (b)[4]            /* Right Vertical line           */
#  define BoxBL(b)   (b)[5]            /* Bottom Left corner            */
#  define BoxBH(b)   (b)[6]            /* Bottom Horizontal line        */
#  define BoxBR(b)   (b)[7]            /* Bottom Right corner           */
#  define BoxMJ(b)   (b)[8]            /* Middle cross Junction         */
#  define BoxLJ(b)   (b)[9]            /* Left tee Junction             */
#  define BoxRJ(b)   (b)[10]           /* Right tee Junction            */
#  define BoxTJ(b)   (b)[11]           /* Top tee Junction              */
#  define BoxBJ(b)   (b)[12]           /* Bottom tee Junction           */
#endif   /*- _TCXLbox_ : End of <TCXLbox.h> ----------------------------*/
