/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1991, Innovative Data Concepts, Inc.
 | All Rights Reserved.
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call 1-215-443-9705.
 *-V--------------------------------------------------------------------*
 | $Header:   tcxldef.h     552.7   19 Jun 1991 17:15:34  $
 |
 | $Log:   tcxldef.h    $
 *-D--------------------------------------------------------------------*
 | <TCXLdef.h> : TCXL global MS-DOS definitions and function prototypes.
 *-N-----------------------[ Notes and Caveats ]------------------------*
 | 1) Included by almost all other <TCXLxxx.h> header files, as shown in
 |    the nesting-tree diagram.
 | 2) Compiler-dependent definitions are isolated in separate files
 |    included here.
 | 3) For all supported MS_DOS compilers, all TCXL functions except those
 |    taking variable arguments use the faster, more compact Pascal
 |    calling convention, defined as CTYP.
 | 4) Compiler-specific "ANSI Keywords Only" options cannot be used with
 |    TCXL, due to use of common extended keywords.
 | 5) TcxlInit() MUST be called on start-up of any program using TCXL!
 |    The Tcxl???Off() macros disable various special features. They MUST
 |    be invoked BEFORE calling TcxlInit() to have any effect.
 | 6) _TcxlTerm() is a registered atexit() function and MUST NOT be
 |    called by ANY user code!
 | 7) The _TCXL_cod_ and _TCXL_dat_ macros are defined as 1 for far code
 |    or data or as 0 for near code or data by the compiler-specific
 |    include-files.
 | 8) The crufty MsXxx() macros exist solely for typecasts to shut up a
 |    lot of MEANINGLESS NOISE in the form of warning messages generated
 |    by the MSC 5.1 and 6.0 MS-DOS compilers about assigning 8-bit
 |    variables to 16-bit values or comparing signed and unsigned values!
 |    They are only defined if MSC is the compiler being used. Just one
 |    of the many inane things needed for portability!
 | 9) The crufty  _????CP macros MAY be needed to cast function-pointer
 |    arguments passed to TCXL functions to avoid some strange problems
 |    and spurious error messages with TC++ 1.0 and other C++ compilers.
 |    They are only defined if __cplusplus is defined.
 | 10) National-language support is enabled by default. This TCXL feature
 |    REQUIRES MS/PC-DOS 3.3 or later. To disable this feature, call
 |    TcxlNlsOff() BEFORE calling TcxlInit().
 *===============[ TCXL 5.52 Include-file Nesting Trees ]===============*
 | Alphabetical order by include-file, reflecting the MS-DOS version.
 | <TCXLdos.h> and compiler-dependent include-files are replaced for
 | ports to other platforms.
 |
 | <TCXLatr.h>     | <TCXLent.h>     | <TCXLkey.h>     | <TCXLstr.h>
 | --------------- |  +-<TCXLfmt.h>  |  +-<TCXLdef.h>  |  +-<TCXLdef.h>
 | <TCXLbox.h>     |  +-<TCXLwin.h>  | --------------- | ---------------
 |  +-<TCXLdef.h>  | --------------- | <TCXLmem.h>     | <TCXLvid.h>
 | --------------- | <TCXLerr.h>     |  +-<TCXLdef.h>  |  +-<TCXLatr.h>
 | <TCXLcod.h>     | --------------- | --------------- |  +-<TCXLdef.h>
 | --------------- | <TCXLfar.h>     | <TCXLmnu.h>     | ---------------
 | <TCXLcur.h>     |  +-<TCXLdef.h>  |  +-<TCXLwin.h>  | <TCXLvUV.h>
 |  +-<TCXLmou.h>  | --------------- | --------------- |  +-<TCXLvid.h>
 |  +-<TCXLvid.h>  | <TCXLfmt.h>     | <TCXLmou.h>     | ---------------
 | --------------- |  +-<TCXLnls.h>  |  +-<TCXLdef.h>  | <TCXLwin.h>
 | <TCXLdef.h>     | --------------- | --------------- |  +-<TCXLvid.h>
 |  +-<TCXL_msc.h> | <TCXLhdw.h>     | <TCXLnls.h>     | ---------------
 |  +-<TCXL_tc.h>  |  +-<TCXLdef.h>  |  +-<TCXLdef.h>  | <TCXL_os.h>
 |  +-<TCXL_ztc.h> | --------------- | --------------- |  +-<TCXLdos.h>
 | --------------- | <TCXLhlp.h>     | <TCXLprn.h>     | ---------------
 | <TCXLdos.h>     |  +-<stdio.h>    |  +-<TCXLdef.h>  | <TCXL_msc.h>
 |  +-<TCXLdef.h>  |  +-<TCXLwin.h>  | --------------- | ---------------
 | --------------- | --------------- | <TCXLsel.h>     | <TCXL_tc.h>
 |                 | <TCXLinp.h>     |  +-<TCXLwin.h>  | ---------------
 |                 |  +-<TCXLkey.h>    --------------- | <TCXL_ztc.h>
 *======================================================================*/
#ifndef  _TCXLdef_
#  define   _TCXLdef_ 1                /* only once!                    */

/*--------------------[ Supported MS-DOS compilers ]--------------------*/
#  undef    _TCXL_cc_
#  undef    _TCXL_msc_
#  undef    _TCXL_cod_
#  undef    _TCXL_dat_
#ifdef __TSC__
#  include  <TCXL_tsc.h>
#else
#  ifdef __TURBOC__           /* Borland TC 2.01, TC++ 1.01 or later    */
#     include  <TCXL_tc.h>
#  else
#     ifdef __ZTC__           /* Zortech C/C++ 2.1 or later (NOT 2.14!) */
#        include  <TCXL_ztc.h>
#     else
#        if defined(M_I86) && !defined(M_XENIX)  /* MS C 5.1, QC 2.0    */
#           include  <TCXL_msc.h>
#        else                                                    /* jpl */
#           ifdef __IBMAIX__             /* RS/6000 with IBM AIX    jpl */
#              include   <TCXL_aix.h>                            /* jpl */
#           else                                                 /* jpl */
#              if defined(M_I86) && defined(M_XENIX)             /* jpl */
#                 include   <TCXL_sco.h>                         /* jpl */
#              endif                                             /* jpl */
#           endif                                                /* jpl */
#        endif
#     endif
#  endif
#  ifndef   _TCXL_cc_
#     error Unsupported MS-DOS Compiler!
#  endif
#endif

/*------------------------[ TCXL configuration ]------------------------*/

#define  TCXLVER  0x0534               /*- TCXL version = 5.52 ---------*/

                                       /*- TclxDbg debug levels --------*/
#define  DBG_NUL  0x0000               /* No error trapping             */
#define  DBG_MEM  0x0001               /* Error-exit of allocation fail */
#define  DBG_WRN  0x0002               /* Warning Box on Window Error   */
#define  DBG_WER  0x0004               /* Error Exit on Window Error    */
#define  DBG_WIN  0x0006               /* Both window debug levels      */
                                       /*- TcxlSys values --------------*/
#define  SYS_DOS  0x0000               /* MS-DOS/PC-DOS/DR_DOS          */
#define  SYS_JDS  0x0001               /* Japan DOS                     */
#define  SYS_OS2  0x0002               /* half an OS ;)                 */
#define  SYS_XNX  0x0003               /* MS/SCO Xenix                  */
#define  SYS_UNX  0x0004               /* AT&T Unix                     */
#define  SYS_BSD  0x0005               /* BSD Unix                      */
#define  SYS_AIX  0x0006               /* IBM AIX                       */
#define  SYS_VMS  0x0007               /* DEC VMS                       */
                                       /*- TcxlEnv/TcxlCfg bits (DOS) --*/
#define  ENV_MOU  0x0001               /* Mouse                         */
#define  ENV_KEY  0x0002               /* Enhanced keyboard             */
#define  ENV_UV   0x0004               /* UltraVision                   */
#define  ENV_MEM  0x0008               /* TCXL memory subsystem         */
#define  ENV_ESA  0x0010               /* EISA bus                      */
#define  ENV_MCA  0x0020               /* MCA bus                       */
#define  ENV_NLS  0x0040               /* National-language support     */
#define  ENV_CUR  0x0080               /* Save cursor position          */

/*----------------[ Portability and shorthand notation ]----------------*/

#define  CON      const
#define  CTYP     PAS                  /* compiler-dependent!           */
#define  GBL      extern
#define  LCL      static
#define  REG      register
#define  SIZ(c)   sizeof(c)
#define  TYP      typedef
#define  UNS      unsigned
#define  VOID     void
#define  VOL      volatile
#define  LOOP     for(;;)              /* endless loop                  */
#ifdef   __cplusplus
#  define   NOARG                      /* remove (void) cruft for C++   */
#else
#  define   NOARG void                 /* leave (void) cruft for C      */
#endif
#ifdef EOS
#  undef EOS
#endif
#define  EOS      '\x00'               /* End_Of_String                 */
#ifdef NUL
#  undef NUL                           /* NulTerm                       */
#endif
#define  NUL      EOS                  /* ASCII NULl char               */
#define  BEL      '\x07'               /* Common ASCII control codes    */
#define  BS       '\x08'
#define  HT       '\x09'
#define  LF       '\x0A'
#define  FF       '\x0C'
#define  CR       '\x0D'
#define  ESC      '\x1B'
#ifdef EOF
#  undef EOF
#endif
#define  EOF      (-1)                 /* End_Of_File                   */
#define  CpmEof   '\x1A'               /* CP/M-style [PDP-8!] ^Z EOF    */
#define  CtlZ     CpmEof               /* ... alias                     */
#ifdef   FALSE
#  undef FALSE
#endif
#ifdef   TRUE
#  undef TRUE
#endif
#define  FALSE    0                    /* Boolean absolutes             */
#define  TRUE     1
#ifdef   YES
#  undef YES
#endif
#ifdef   NO
#  undef NO
#endif
#define  YES      TRUE                 /* ... aliases                   */
#define  NO       FALSE
#ifdef   ON
#  undef ON
#endif
#ifdef   OFF
#  undef OFF
#endif
#define  ON       TRUE
#define  OFF      FALSE

/*-------------------[ Error-return and exit values ]-------------------*/

#define  ERR_MEM  (-2)                 /* allocation failure            */
#define  ERR_ARG  (-1)                 /* argument failure              */
#define  ERR_NUL  0                    /* successful return             */

/*-----------------[ Error-return and debugging macros ]----------------*/

#ifdef TCXLDBG
#define  WERR_ARG(e) { TcxlErr = (e); \
                     if(TcxlDbg & DBG_WIN) WinFail(__FILE__,__LINE__); \
                     return(ERR_ARG); }

#define  WERR_AR0(e) { TcxlErr = (e); \
                     if(TcxlDbg & DBG_WIN) WinFail(__FILE__,__LINE__); \
                     return(ERR_NUL); }

#define  WERR_AR1(e) { TcxlErr = (e); \
                     if(TcxlDbg & DBG_WIN) WinFail(__FILE__,__LINE__); \
                     return; }

#define  WERR_ARC(e) { TcxlErr = (e); \
                     if(TcxlDbg & DBG_WIN) WinFail(__FILE__,__LINE__); \
                     return(MsChr(EOS)); }

#define  WERR_ARN(e) { TcxlErr = (e); \
                     if(TcxlDbg & DBG_WIN) WinFail(__FILE__,__LINE__); \
                     return(NULL); }

#define  WERR_MEM    { TcxlErr = W_ALLOCERR; \
                     if(!(TcxlDbg & DBG_MEM)) return(ERR_MEM); \
                     else MemFail(__FILE__,__LINE__); }

#define  WERR_MEM1   { TcxlErr = W_ALLOCERR; \
                     if(!(TcxlDbg & DBG_MEM)) return; \
                     else MemFail(__FILE__,__LINE__); }

#define  WERR_MEM2   { TcxlErr = W_ALLOCERR; \
                     if(!(TcxlDbg & DBG_MEM)) return(NULL); \
                     else MemFail(__FILE__,__LINE__); }
#else
#define  WERR_ARG(e) { TcxlErr = (e); return(ERR_ARG); }
#define  WERR_AR0(e) { TcxlErr = (e); return(ERR_NUL); }
#define  WERR_AR1(e) { TcxlErr = (e); return; }
#define  WERR_ARC(e) { TcxlErr = (e); return(EOS); }
#define  WERR_ARN(e) { TcxlErr = (e); return(NULL); }
#define  WERR_MEM    { TcxlErr = W_ALLOCERR; return(ERR_MEM); }
#define  WERR_MEM1   { TcxlErr = W_ALLOCERR; return; }
#define  WERR_MEM2   return(NULL)
#endif
#define  WERR_ESC    { TcxlErr = W_ESCPRESS; return(ERR_ARG); }
#define  WERR_NUL    { TcxlErr = 0; return(ERR_NUL); }

/*---------[ TCXL standard object, pointer and indirect types ]---------*/
/*                Object Pointer Indirect                               */
TYP   VOID              *AnyP, **AnyI; /* anonymous void pointer        */
TYP   VOID FAR          *AnyFP;        /* ... far-pointer               */
TYP   char        ChrT, *ChrP, **ChrI; /* 8-bit char                    */
TYP   ChrT FAR          *ChrFP;        /* ... far-pointer               */
TYP   ChrT              *StrP, **StrI; /* NulTerm string                */
TYP   UNS char    BytT, *BytP, **BytI; /* 8-bit unsigned byte           */
TYP   BytT FAR          *BytFP;        /* ... far-pointer               */
TYP   BytT        FlgT, *FlgP, **FlgI; /* 8-bit Boolean flag            */
TYP   short       IntT, *IntP, **IntI; /* 16-bit signed int             */
TYP   IntT FAR          *IntFP;        /* ... far-pointer               */
TYP   UNS short   WrdT, *WrdP, **WrdI; /* 16-bit unsigned word          */
TYP   WrdT FAR          *WrdFP;        /* ... far-pointer               */
TYP   long        LngT, *LngP, **LngI; /* 32-bit signed long            */
TYP   LngT FAR          *LngFP;        /* ... far-pointer               */
TYP   UNS long    DwdT, *DwdP, **DwdI; /* 32-bit unsigned dword         */
TYP   DwdT FAR          *DwdFP;        /* ... far-pointer               */
TYP   float       FltT, *FltP, **FltI; /* 32-bit real                   */
TYP   double      DblT, *DblP, **DblI; /* 64-bit real                   */
TYP   WrdT        LenT, *LenP, **LenI; /* alias for ANSI size_t         */
TYP   LngT        PosT, *PosP, **PosI; /* alias for ANSI fpos_t         */
TYP   WrdT        NdxT, *NdxP, **NdxI; /* unsigned array-indices        */
TYP   IntT        ArgT;                /* bytes/chars as ints           */
TYP   UNS         BitT;                /* unsigned bitfields            */

/*------[ Portability type for accessing Low/High bytes of a word ]-----*/

TYP   union    _Port _PortT;
union _Port                   /*-[ Portability for byte-sexing ]--------*/
{  WrdT     pwrd;             /* 00 : PortW : Overlay word              */
#ifdef __WORDSWAP__           /*                                    jpl */
   struct                     /*                                        */
   {  BytT  lob;              /* 00 : PortL : Low byte                  */
      BytT  hib;              /* 01 : PortH : High byte                 */
   }  p;                      /*                                        */
#else                         /*                                    jpl */
   struct                     /*                                    jpl */
   {  BytT  hib;              /* 01 : PortH : High byte             jpl */
      BytT  lob;              /* 00 : PortL : Low byte              jpl */
   }  p;                      /*                                    jpl */
#endif                        /*                                    jpl */
};                            /* 02 ]-----------------------------------*/
#define  _PortW(x)  ((x).pwrd)               /* Overlay word            */
#define  _PortL(x)  ((x).p.lob)              /* Low byte                */
#define  _PortH(x)  ((x).p.hib)              /* High byte               */

/*--------------------[ TCXL-specific type-aliases ]--------------------*/

TYP   BytT  AtrT, *AtrP;               /* video attribute               */
TYP   WrdT  KeyT, *KeyP;               /* keycode (char/scan)           */
TYP   IntT  TagT, *TagP;               /* item/field/help tag-id        */
TYP   IntT  WndT, *WndP;               /* window handle                 */
#ifdef   _TCXL_msc_
#  define   MsByt(x) (BytT)(x)         /* crufty casts to shut up MSC   */
#  define   MsAtr(x) (AtrT)(x)
#  define   MsChr(x) (ChrT)(x)
#  define   MsInt(x) (IntT)(x)
#  define   MsWrd(x) (WrdT)(x)
#else
#  define   MsByt(x) (x)               /* no crufty casts otherwise     */
#  define   MsAtr(x) (x)
#  define   MsChr(x) (x)
#  define   MsInt(x) (x)
#  define   MsWrd(x) (x)
#endif

/*----------------[ Common TCXL function-pointer types ]----------------*/

TYP   VOID  (CTYP *VfvCP)(NOARG);      /* VOID (CTYP *function)(NOARG)  */
TYP   VOID  (CTYP *VfcCP)(ChrT);       /* VOID (CTYP *function)(ChrT)   */
TYP   VOID  (CTYP *VfiCP)(IntT);       /* VOID (CTYP *function)(IntT)   */
TYP   VOID  (CTYP *CfcCP)(ChrT);       /* ChrT (CTYP *function)(ChrT)   */
TYP   IntT  (CTYP *IfiCP)(IntT);       /* IntT (CTYP *function)(IntT)   */
TYP   IntT  (CTYP *IfcpCP)(ChrP);      /* IntT (CTYP *function)(ChrP)   */
TYP   WrdT  (CTYP *WfipCP)(IntP);      /* WrdT (CTYP *function)(IntP)   */
TYP   KeyT  (CTYP *KfvCP)(NOARG);      /* KeyT (CTYP *function)(NOARG)  */

#ifdef __cplusplus
#define  _VFVCP(f)   (VfvCP)(f)        /* C++ function-pointer casts    */
#define  _VFICP(f)   (VfiCP)(f)
#define  _CFCCP(f)   (CfcCP)(f)
#define  _IFICP(f)   (IfiCP)(f)
#define  _IFCPCP(f)  (IfcpCP)(f)
#define  _WFIPCP(f)  (WfipCP)(f)
#define  _KFVCP(f)   (KfvCP)(f)
#else
#define  _VFVCP(f)   (f)               /* Casts not needed for C        */
#define  _VFICP(f)   (f)
#define  _CFCCP(f)   (f)
#define  _IFICP(f)   (f)
#define  _IFCPCP(f)  (f)
#define  _WFIPCP(f)  (f)
#define  _KFVCP(f)   (f)
#endif

/*------------[ Common TCXL data-objects and access macros ]------------*/

TYP   struct   _Tcxl TcxlT;            /* Object, pointer types         */
TYP   union    _Kcod KcodT, *KcodP;
TYP   union    _Vcel VcelT, *VcelP, FAR *VcelFP;
TYP   union    _Vpos VposT, *VposP;

struct   _Tcxl                /*-[ TCXL-control object ]----------------*/
{  IntT     terr;             /* 00|00 : TcxlErr : Error code           */
   IntT     tdbg;             /* 02|02 : TcxlDbg : Debug-level          */
   WrdT     tsys;             /* 04|04 : TcxlSys : Operating system     */
   WrdT     tsvr;             /* 06|06 : TcxlSvr : System version       */
   WrdT     tcty;             /* 08|08 : TcxlCty : Country-code         */
   WrdT     tenv;             /* 0A|0A : TcxlEnv : Environment bits     */
   WrdT     tcfg;             /* 0C|0C : TcxlCfg : Configuration bits   */
};                            /* 0E|0E ]--------------------------------*/

GBL   TcxlT CDC   _TcxlCtl;   /*- global TCXL control object -----------*/
#define  TcxlErr  (_TcxlCtl.terr)               /* Error code           */
#define  TcxlDbg  (_TcxlCtl.tdbg)               /* Debug-level          */
#define  TcxlSys  (_TcxlCtl.tsys)               /* System               */
#define  TcxlDos  (TcxlSys == SYS_DOS)          /*    MS/PC-DOS 2.0+    */
#define  TcxlJds  (TcxlSys == SYS_JDS)          /*    Japan DOS         */
#define  TcxlOs2  (TcxlSys == SYS_OS2)          /*    Half an OS        */
#define  TcxlXnx  (TcxlSys == SYS_XNX)          /*    SCO Xenix         */
#define  TcxlUnx  (TcxlSys == SYS_UNX)          /*    AT&T Unix         */
#define  TcxlBsd  (TcxlSys == SYS_BSD)          /*    BSD Unix          */
#define  TcxlAix  (TcxlSys == SYS_AIX)          /*    IBM AIX           */
#define  TcxlVms  (TcxlSys == SYS_VMS)          /*    DEC VAX/VMS       */
#define  TcxlSvr  (_TcxlCtl.tsvr)               /* System version       */
#define  TcxlCty  (_TcxlCtl.tcty)               /* Country-code         */
#define  TcxlEnv  (_TcxlCtl.tenv)               /* Environment (DOS)    */
#define  TcxlMou  (0 != (TcxlEnv & ENV_MOU))    /*    Mouse             */
#define  TcxlKey  (0 != (TcxlEnv & ENV_KEY))    /*    Enhanced keyboard */
#define  TcxlUv   (0 != (TcxlEnv & ENV_UV))     /*    UltraVision       */
#define  TcxlMem  (0 != (TcxlEnv & ENV_MEM))    /*    TCXL memory system*/
#define  TcxlEsa  (0 != (TcxlEnv & ENV_ESA))    /*    EISA bus          */
#define  TcxlMca  (0 != (TcxlEnv & ENV_MCA))    /*    MCA bus           */
#define  TcxlNls  (0 != (TcxlEnv & ENV_NLS))    /*    National-language */
#define  TcxlCfg  (_TcxlCtl.tcfg)               /* Configuration bits   */

union    _Kcod                /*-[ Complete keycode object ]------------*/
{  KeyT     ckey;             /* 00|00 : KcodKey() : Word overlay       */
#ifdef __WORDSWAP__           /*                                    jpl */
   struct                     /*                                        */
   {  BytT  asc;              /* 00|00 : KcodAsc() : ASCII char | 0=ext */
      BytT  scn;              /* 01|01 : KcodScn() : Scancode           */
   }  c;                      /*                                        */
#else                         /*                                    jpl */
   struct                     /*                                    jpl */
   {  BytT  scn;              /* 00|00 : KcodScn() : Scancode       jpl */
      BytT  asc;              /* 01|01 : KcodAsc() : ASCII char |   jpl */
   }  c;                      /*                                    jpl */
#endif                        /*                                    jpl */
};                            /* 02|02 ]--------------------------------*/
#define  KcodKey(x)     ((x).ckey)
#define  KcodAsc(x)     ((x).c.asc)
#define  KcodScn(x)     ((x).c.scn)

union    _Vcel                /*-[ Video text-cell object ]-------------*/
{  WrdT     cwrd;             /* 00 : VcelW : Overlay word              */
#ifdef __WORDSWAP__           /*                                    jpl */
   struct                     /*                                        */
   {  ChrT  chr;              /* 00 : VcelC : Character                 */
      AtrT  atr;              /* 01 : VcelA : Attribute                 */
   }  c;                      /*                                        */
#else                         /*                                    jpl */
   struct                     /*                                    jpl */
   {  AtrT  atr;              /* 00 : VcelA : Attribute             jpl */
      ChrT  chr;              /* 01 : VcelC : Character             jpl */
   }  c;                      /*                                    jpl */
#endif                        /*                                    jpl */
};                            /* 02 ]-----------------------------------*/
#define  VcelW(x)  ((x).cwrd)                /* Overlay word            */
#define  VcelC(x)  ((x).c.chr)               /* Character               */
#define  VcelA(x)  ((x).c.atr)               /* Attribute               */

union    _Vpos                /*-[ Video text-position object ]---------*/
{  WrdT     pwrd;             /* 00 : VposW : Overlay word              */
#ifdef __WORDSWAP__           /*                                    jpl */
   struct                     /*                                        */
   {  BytT  col;              /* 00 : VposC : Text-column               */
      BytT  row;              /* 01 : VposR : Text-row                  */
   }  p;                      /*                                        */
#else                         /*                                    jpl */
   struct                     /*                                    jpl */
   {  BytT  row;              /* 00 : VposR : Text-row              jpl */
      BytT  col;              /* 01 : VposC : Text-column           jpl */
   }  p;                      /*                                    jpl */
#endif                        /*                                    jpl */
};                            /* 02 ]-----------------------------------*/
#define  VposW(x)  ((x).pwrd)                /* Overlay word            */
#define  VposC(x)  ((x).p.col)               /* Text-column             */
#define  VposR(x)  ((x).p.row)               /* Text-row                */

/*--------------------------[ Utility macros ]--------------------------*
 | These macros replace the standard C min() and max() macros, which may
 | not be defined, and add two other very useful ones.  C++ often doesn't
 | define min() and max() to prevent name-space collisions with member
 | functions.  BEWARE OF SIDE  EFFECTS!
 *----------------------------------------------------------------------*/

#define  MinV(a,b)   ((a)<(b) ? (a) : (b))         /* Minimum value     */
#define  MaxV(a,b)   ((a)>(b) ? (a) : (b))         /* Maximum value     */
#define  AbsV(a)     ((a)<0) ? -(a) : (a))         /* Absolute value    */
#define  DifV(a,b)   ((a)<(b) ? (b)-(a) : (a)-(b)) /* Absolute delta    */

/*------------------------[ Function prototypes ]-----------------------*/

#ifdef   __cplusplus                   /* no mangling, please           */
   extern   "C"   {
#endif
VOID  CTYP  TcxlInit(NOARG);           /* Initialize TCXL               */
VOID        TcxlCurOff(NOARG);         /* Disable cursor-restore on exit*/
VOID        TcxlKeyOff(NOARG);         /* Disable enhanced-keyboard test*/
VOID        TcxlMemOff(NOARG);         /* Disable memory-subsystem      */
VOID        TcxlMouOff(NOARG);         /* Disable mouse support         */
VOID        TcxlNlsOff(NOARG);         /* Disable national-language     */
VOID  CDC   _TcxlTerm(NOARG);          /* INTERNAL atexit() function    */
WrdT        TcxlVer(NOARG);            /* TCXL version number           */
VOID        TcxlVuvOff(NOARG);         /* Disable UltraVision support   */
#ifdef TCXLDBG
                              /*- TCXL debugging pop-ups ---------------*/
VOID  CTYP  MemFail(ChrP Module,       /* Out-of-memory exit            */
   IntT LineNo);
VOID  CTYP  WinFail(ChrP Module,       /* Window-error warning/exit     */
   IntT LineNo);
#endif
                              /*- General utility ----------------------*/
VOID        Beep(NOARG);               /* Honk the horn                 */
ChrP  CTYP  RandFile(NOARG);           /* Generate random filename      */
VOID  CTYP  Sound(WrdT pv, WrdT dt);   /* Sound tone <pv> for time <dt> */
ChrP  CTYP  SysDate(IntT d);           /* System date as string         */
ChrP  CTYP  SysTime(IntT t);           /* System time as string         */
IntT  PAS   TabNxt(IntT c, IntT w);    /* Next tab-stop                 */
VOID        _Delay(WrdT d);            /* Delay for <d> clock-ticks     */
VOID  PAS   _Delay_(WrdT d);
VOID  PAS   _StdOut(ChrT ch);          /* Put char to StdOut            */
VOID  PAS   _StdOutS(ChrP s);          /* Put string to StdOut          */
DwdT  PAS   _Timer(NOARG);             /* Get system timer              */
VOID  PAS   _WaitMs(IntT ms);          /* Wait for <ms> milliseconds    */

#if (_TCXL_cc_ >= 128)                 /* need misc defs            jpl */
ChrP  CDC   itoa(IntT v, ChrP s, IntT r);
IntT  CTYP  strcmpi(ChrP a, ChrP s);
IntT  CTYP  strnicmp(ChrP a, ChrP s, IntT n);
ChrP  CTYP  strupr(ChrP s);
#endif

                              /*- Implementation macros ----------------*/
#define  _Delay(d)      _Delay_(d)
#define  Beep()         _StdOut(BEL)
#define  TcxlCurOff()   (TcxlCfg &= ~ENV_CUR)
#define  TcxlKeyOff()   (TcxlCfg &= ~ENV_KEY)
#define  TcxlMemOff()   (TcxlCfg &= ~ENV_MEM)
#define  TcxlMouOff()   (TcxlCfg &= ~ENV_MOU)
#define  TcxlNlsOff()   (TcxlCfg &= ~ENV_NLS)
#define  TcxlVer()      TCXLVER
#define  TcxlVuvOff()   (TcxlCfg &= ~ENV_UV)
#ifdef __cplusplus
   }
#endif
#endif   /*- _TCXLdef_ : End of TCXLDef.h ------------------------------*/
