/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1991, Innovative Data Concepts, Inc.
 | All Rights Reserved.
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call  1-215-443-9705.
 *-V--------------------------------------------------------------------*
 | $Header:   tcxlerr.h     552.0   17 Mar 1991 18:26:34  $
 |
 | $Log:   tcxlerr.h    $
 *-D--------------------------------------------------------------------*
 | <TCXLerr.h> : Definitions of TCXL window error and diagnostic codes.
 *-N-----------------------[ Notes and Caveats ]------------------------*
 | 1) Included by <TCXLwin.h>.
 | 2) These values are inherited from CXL and WILL CHANGE for TCXL 6.0!
 | 3) TCXL 5.5 functions no longer return these values. They set global
 |    TclxErr and return the following.
 |       ERR_NUL = 0    for success
 |       ERR_ARG = -1   argument failure
 |       ERR_MEM = -2   allocation failure
 *======================================================================*/
#ifndef  _TCXLerr_
#  define   _TCXLerr_ 1             /*- TcxlErr error-codes ------------*/
#  define   W_ESCPRESS  0x01        /* Escape key was pressed           */
#  define   W_ALLOCERR  0x02        /* memory allocation error          */
#  define   W_NOTFOUND  0x03        /* record not found                 */
#  define   W_NOACTIVE  0x04        /* no active window                 */
#  define   W_INVCOORD  0x05        /* invalid coordinates              */
#  define   W_INVFORMT  0x06        /* invalid format string            */
#  define   W_NOINPDEF  0x07        /* no entry-fields defined          */
#  define   W_STRLONG   0x08        /* string too long for window       */
#  define   W_INVBTYPE  0x09        /* invalid box type                 */
#  define   W_NOBORDER  0x0A        /* no window border                 */
#  define   W_NOHIDDEN  0x0B        /* no hidden windows                */
#  define   W_NOTHIDD   0x0C        /* window is not hidden             */
#  define   W_NOSELECT  0x0D        /* no selectable menu items         */
#  define   W_NOITMDEF  0x0E        /* no menu items defined            */
#  define   W_NOMNUEND  0x0F        /* no end of menu specified         */
#  define   W_NOMNUDEF  0x10        /* no menu defined                  */
#  define   W_NOMNUBEG  0x11        /* no begin of menu specified       */
#  define   W_NOFRMDEF  0x12        /* no entry-form defined            */
#  define   W_NOFRMBEG  0x13        /* no start of form specified       */
#  define   W_NOHLPDEF  0x14        /* no help defined                  */
#  define   W_HLPSTKOV  0x15        /* help stack overflow              */
#  define   W_HLPSTKUN  0x16        /* help stack underflow             */
#  define   W_DOSERROR  0x17        /* DOS error                        */
#  define   W_NOMATCH   0x18        /* no files matched input filespec  */
#  define   W_INVTAGID  0x19        /* invalid tag identifier           */
#  define   W_INVPATH   0x1A        /* path invalid or not found        */
#  define   W_FRMISDEF  0x1B        /* entry-form already defined       */
#  define   W_FRMSTKOV  0x1C        /* form stack overflow              */
#  define   W_FRMSTKUN  0x1D        /* form stack underflow             */
#  define   W_NOHLPFIL  0x1E        /* no help-file found               */
#  define   W_INP2MANY  0x1F        /* too many entry-fields            */
#  define   W_MNU2MANY  0x20        /* too many menu-items              */
#  define   W_INP2FEW   0x21        /* not enough entry-fields          */
#  define   W_NOINPENA  0x22        /* no enabled entry-field           */
#  define   W_MNU2FEW   0x23        /* not enough menu items            */
#endif   /* _TCXLerr_ : End of TCXLerr.h -------------------------------*/
