/*=====[ The TesSeRact(TM) CXL User Interface Development System ]======*
 | Copyright (c) 1987-1991, Innovative Data Concepts, Inc.
 | All Rights Reserved.
 |
 | This Library is part of IDC's TesSeRact Development Tools product
 | line. For information about other IDC products, call  1-215-443-9705.
 *-V--------------------------------------------------------------------*
 | $Header:   tcxlvuv.h     552.0   17 Mar 1991 18:26:58  $
 |
 | $Log:   tcxlvuv.h    $
 *-D--------------------------------------------------------------------*
 | <TCXLvUV.h> : Definitions and prototypes for TCXL UltraVision support.
 *-N-----------------------[ Notes and Caveats ]------------------------*
 | 1) UltraVision(tm) is an MS/PC-DOS-specific, video-enhancement utility
 |    for EGA/VGA distributed by Personics.
 *======================================================================*/
#ifndef  _TCXLvUV_
#  define   _TCXLvUV_ 1                /* Only once!                    */
#  ifndef   _TCXLvid_
#     include  <TCXLvid.h>             /* Video definitions             */
#  endif
                              /*- UltraVision Flags --------------------*/
#define  VU_RES      0x80              /* UltraVision resident          */
#define  VU_ACT      0x40              /* UltraVision active            */
                              /*- UltraVision Card Codes ---------------*/
#define  VU_GEC      0x00              /* Generic EGA, Color            */
#define  VU_GEM      0x04              /* Generic EGA, Monochrome       */
#define  VU_GVV      0x05              /* Generic VGA, VGA monitor      */
#define  VU_PVV      0x06              /* Paradise VGA, VGA monitor     */
#define  VU_HVV      0x07              /* Super VGA, VGA monitor        */
#define  VU_BEE      0x0A              /* UV EGA Booster, EGA monitor   */
#define  VU_NEE      0x0B              /* NEC GB-1, EGA monitor         */
#define  VU_SEE      0x0C              /* Genoa SuperEGA, EGA monitor   */
#define  VU_AEE      0x0D              /* Alt EGA Booster, EGA monitor  */
#define  VU_AEM      0x0E              /* Alt EGA Booster, Monochrome   */
#define  VU_GVA      0x19              /* Generic VGA, Autosync         */
#define  VU_PVA      0x1A              /* Paradise VGA, Autosync        */
#define  VU_HVA      0x1B              /* Super VGA, Autosync           */
#define  VU_BEA      0x14              /* UV EGA Booster, Autosync      */
#define  VU_NEA      0x15              /* NEC GB-1, Autosync            */
#define  VU_SEA      0x16              /* Genoa SuperEGA, Autosync      */
#define  VU_AEA      0x17              /* Alt EGA Booster, Autosync     */
                              /*- UltraVision Video Modes --------------*/
#define  VU_A25      0x11              /* 80x25                         */
#define  VU_A43      0x12              /* 80x43 (EGA), 80x50 (VGA)      */
#define  VU_A34      0x13              /* 80x34 (EGA), 80x36 (VGA)      */
#define  VU_A60      0x14              /* 80x60 (EGA), 80x63 (VGA)      */
#define  VU_B25      0x19              /* 94x25                         */
#define  VU_B43      0x1A              /* 94x43 (EGA), 94x50 (VGA)      */
#define  VU_B36      0x1B              /* 94x36                         */
#define  VU_B63      0x1C              /* 94x63                         */
#define  VU_C25      0x21              /* 108x25                        */
#define  VU_C43      0x22              /* 108x43 (EGA), 108x50 (VGA)    */
#define  VU_C34      0x23              /* 108x34 (EGA), 108x36 (VGA)    */
#define  VU_C60      0x24              /* 108x60 (EGA), 108x63 (VGA)    */
#define  VU_D25      0x31              /* 120x25                        */
#define  VU_D43      0x32              /* 120x43 (EGA), 120x50 (VGA)    */
#define  VU_D36      0x39              /* 120x36                        */
#define  VU_D63      0x3A              /* 120x63                        */
#define  VU_E25      0x33              /* 132x25                        */
#define  VU_E44      0x34              /* 132x44, 132x50 (SuperVGA)     */
#define  VU_E36      0x3B              /* 132x36                        */
#define  VU_E60      0x3C              /* 132x60                        */

/*------------------[ Data objects and access macros ]------------------*/

TYP   struct   _Vuv  _VuvT, *_VuvP;    /* Object, pointer types         */

struct   _Vuv                 /*-[ UltraVision data object ]------------*/
{  DwdT     vptr;             /* 00|00 : _VuvPtr : Table pointer        */
   BytT     vflg;             /* 04|04 : _VuvFlg : Flags                */
   BytT     vcrd;             /* 05|05 : _VuvCrd : Card code            */
   BytT     vmod;             /* 06|06 : _VuvMod : Text Mode            */
   BytT     vfut;             /* 07|07 : Reserved for future            */
};                            /* 08|08 ]--------------------------------*/

GBL   _VuvT CDC   _VuvCtl;             /*- Global UltraVision object ---*/
#define  _VuvPtr     (_VuvCtl.vptr)             /* Table pointer        */
#define  _VuvFlg     (_VuvCtl.vflg)             /* Flags                */
#define  _VuvRes     (0 != (_VuvFlg & VU_RES))     /* Resident          */
#define  _VuvAct     (0 != (_VuvFlg & VU_ACT))     /* Active            */
#define  _VuvCrd     (_VuvCtl.vcrd)             /* Card code            */
#define  _VuvMod     (_VuvCtl.vmod)             /* Text mode            */

/*------------------------[ Function prototypes ]-----------------------*/

#ifdef __cplusplus                     /* No mangling, please           */
   extern   "C"   {
#endif
VOID  PAS   _VuvDis(NOARG);            /* Disable UltraVision           */
VOID  PAS   _VuvEna(NOARG);            /* Enable UltraVision            */
IntT  PAS   _VuvGet(NOARG);            /* Get UltraVision text-mode     */
VOID  PAS   _VuvSet(IntT md);          /* Set UltraVision text-mode     */
IntT  PAS   _VuvVal(IntT md);          /* Validate UltraVision text-mode*/
#ifdef __cplusplus
   }
#endif
#endif   /*- _TCXLvUV_ : End of TCXLvUV.h ------------------------------*/
